Subject: Re: [PATCH 00/16] Remove hash page table slot tracking from linux PTE

From: Paul Mackerras <[email-masked]>
Date: Wed, 1 Nov 2017 22:02:41 +1100

On Sun, Oct 29, 2017 at 05:51:06PM -0700, Ram Pai wrote:
> On Mon, Oct 30, 2017 at 09:04:17AM +1100, Paul Mackerras wrote:
> > On Sat, Oct 28, 2017 at 03:35:32PM -0700, Ram Pai wrote:
> > > 
> > > I like the idea of not tracking the slots at all. It is something the
> > > guest should not be knowing or tracking.
> > 
> > Why do you say that?
> 
> 'slot' is a internal mechanism used by the hash table to accelerate
> mapping an address to a hash-page.  If the hash-table implementation
> choose to use a different mechanism to accelerate the mapping, it can't
> because that mechanism is baked into the logic of all the consumers.

Not all operating systems use the HPT as a cache of translations that
are also stored somewhere, as Linux does.  Those OSes are perfectly
entitled to control the slot allocation for their own purposes in
whatever way they want.  So having the interface use the slot number
is fine; just as having alternative interfaces that don't need to
specify the slot number for the kind of usage that Linux does is also
fine.

Paul.